
import java.applet.*;
import java.awt.*;
import java.awt.event.*;

//----------------------------------------------------------

public class TorkadoAlphaExc2 extends Applet implements ActionListener, Runnable
{
  int width = 600, totalWidth, height;         // Abmessungen
  Graphics g1, g2;
  Image offscreen;
  Color bgColor = Color.white;                  // Hintergrundfarbe Grafikbereich
  Color pColor = new Color(200,200,200);        // Farbe Hintergrund Formular
  Color sColor = Color.black;                   // Schriftfarbe
  Color xColor = Color.red;                     // Farbe X-Achse
  Color yColor = new Color(0,128,0);            // Farbe Y-Achse
  Color zColor = Color.blue;                    // Farbe Z-Achse
  Color a1Color = Color.black;                  // 4 Farben KurveA
  Color a2Color = Color.black;
  Color a3Color = Color.red;
  Color a4Color = Color.red;
  Color b1Color = Color.magenta;                // 4 Farben KurveB
  Color b2Color = Color.magenta;
  Color b3Color = Color.blue;
  Color b4Color = Color.blue;
  Font fSS;                                    // Zeichensatz
  Panel p;
  Checkbox cbA, cbB;                           // Schalter
  Button bPause;
  Label lR, lr, lWA, lWB, lexc1, lexc2, lS;
  TextField tfR, tfr, tfwA, tfwB, tfexc1, tfexc2, tfS, tfTheta;
  Thread thr;
  double t;                                    // Zeit (s)
  boolean on;                                  // Flag fr Bewegung
  final double omega = -Math.PI/10;            // Winkelgeschwindigkeit (1/s)
  final double PI=Math.PI, zPI=2*Math.PI;
  int u0, v0;                                  // Ursprung
  double theta;                                // Winkel bezglich x-y-Ebene
  double phi;                                  // Winkel bezglich x-Achse
  double a1, a2, b1, b2, b3, c1, c2, c3;       // Koeffizienten fr Projektion
  double vR, vr, wA, wB, kreisteile;              // Torusgren R,r, Windg., Kreisteile
  double exc1=0.2, exc2=0.2, exc1s=0, exc2write=0;
  final int max = 1000;                        // Maximalwert fr Koordinaten

  String KA,KB;
  String lang;                                 // Sprache (Parameter aus Applet-Tag)
  String[] text;
  String[] german = { "Mae und Winkelschritte", "Schrittanzahl", "Kipp-Winkel", "Stop / Weiter", "",
  "Daten speichern im HTM-Code","Download www.webstickers.de"," G.Mueller 2003,  W.Fendt 1998" };
//um z-achse,um Schlauch

//----------------------------------------------------------

 // Komponente zum Panel hinzufgen:
  // comp .... Komponente
  // color ... Hintergrundfarbe
  // x ....... Spalte
  // y ....... Zeile
  // w ....... Breite
  // top usw.. Abstnde zu den benachbarten Komponenten

  void addComponent (Component comp, Color color, int x, int y, int w,
    int top, int left, int bottom, int right)
  {
    GridBagConstraints c = new GridBagConstraints();
    c.gridx = x; c.gridy = y; c.gridwidth = w; c.gridheight = 1;
    c.fill = GridBagConstraints.HORIZONTAL;
    c.anchor = GridBagConstraints.CENTER;
    c.weightx = 1; c.weighty = 1;
    c.insets = new Insets(top,left,bottom,right);
    ((GridBagLayout)p.getLayout()).setConstraints(comp,c);
    comp.setFont(fSS); comp.setBackground(color);
    p.add(comp);
  }





//----------------------------------------------------------

  public void init()
  {
    int i, j;
    totalWidth = getSize().width;
    height = getSize().height;

    g1 = getGraphics();
    offscreen = createImage(width,height);
    g2 = offscreen.getGraphics();
    fSS = new Font("SansSerif",Font.BOLD,12);
    setLayout(new BorderLayout());
    u0 = width/2; v0 = height/2;
  }

//----------------------------------------------------------

 // Starten der Animation:

  public void start ()
  {

    String s;
    double wink=30.0;
    text = german;
    lang = getParameter("language");
    if (lang == null) lang = "German";
    /*
    if (lang.equals("English")) text = english;
    else if (lang.equals("French")) text = french;
    else if (lang.equals("Italian")) text = italian;
    */

    p = new Panel();
    p.setLayout(new GridBagLayout());
    p.setBackground(pColor);
    addComponent(new Label(text[0]),pColor,0,0,3,30,10,0,10);

    lR = new Label("R ="); lR.setForeground(Color.black);
    addComponent(lR,pColor,0,1,1,0,60,0,0);

    tfR = new TextField(8); tfR.setText("4");
    addComponent(tfR,Color.white,1,1,1,0,0,0,20);

    lr = new Label("r ="); lr.setForeground(Color.black);
    addComponent(lr,pColor,0,2,1,0,60,0,0);

    tfr = new TextField(8); tfr.setText("4");
    addComponent(tfr,Color.white,1,2,1,0,0,0,20);

    lexc1 = new Label("exc1 ="); lexc1.setForeground(Color.black);
    addComponent(lexc1,pColor,0,3,1,0,60,0,0);

    tfexc1 = new TextField(8); tfexc1.setText("0.2");
    addComponent(tfexc1,Color.white,1,3,1,0,0,0,20);

    lexc2 = new Label("exc2 = --"); lexc2.setForeground(Color.black);
    addComponent(lexc2,pColor,0,4,1,0,60,0,0);

    tfexc2 = new TextField(8); tfexc2.setText("0.2");
    addComponent(tfexc2,Color.white,1,4,1,0,0,0,20);


    lWA = new Label("d phi ="); lWA.setForeground(Color.black);
    addComponent(lWA,pColor,0,5,1,0,60,0,0);

    tfwA = new TextField(8); tfwA.setText("32");
    addComponent(tfwA,Color.white,1,5,1,0,0,0,20);

    lWB = new Label("d theta ="); lWB.setForeground(Color.black);
    addComponent(lWB,pColor,0,6,1,0,60,0,0);

    tfwB = new TextField(8); tfwB.setText("32");
    addComponent(tfwB,Color.white,1,6,1,0,0,0,20);

    lS = new Label(text[1]); lS.setForeground(Color.black);
    addComponent(lS,pColor,0,7,1,0,10,0,0);

    tfS = new TextField(4); tfS.setText("360");
    addComponent(tfS,Color.white,1,7,1,0,0,0,20);

    addComponent(new Label(text[2]),pColor,0,8,1,0,10,0,0);

    tfTheta = new TextField(4); tfTheta.setText("30");
    addComponent(tfTheta,Color.white,1,8,1,10,0,0,20);

    s = getParameter("anzeigenKurveA");
    if (s == null) cbA = new Checkbox("KurveA", true);
	if ("false".equals(s))
	{ cbA = new Checkbox("KurveA", false);}
	else
	{ cbA = new Checkbox("KurveA", true); }

	s = getParameter("anzeigenKurveB");
	if (s == null) cbB = new Checkbox("KurveB", true);
	if ("false".equals(s))
	{ cbB = new Checkbox("KurveB",false); }
	else
	{ cbB = new Checkbox("KurveB", true); }

	addComponent(cbA,pColor,0,9,1,0,40,0,0);       // Hinzufgen zur Schaltflche
	addComponent(cbB,pColor,1,9,1,0,0,0,0);

    bPause = new Button(text[3]);
    addComponent(bPause,Color.white,0,10,4,10,10,0,10);
    addComponent(new Label(text[4]),pColor,0,11,4,0,10,0,0);
    addComponent(new Label(text[5]),pColor,0,12,4,0,10,0,0);
    addComponent(new Label(text[6]),pColor,0,13,4,0,10,0,0);
    addComponent(new Label(text[7]),pColor,0,14,4,0,10,0,0);
    add("East",p);

    tfR.addActionListener(this);
    tfr.addActionListener(this);
    tfexc1.addActionListener(this);
    tfexc2.addActionListener(this);
    tfwA.addActionListener(this);
    tfwB.addActionListener(this);
    tfS.addActionListener(this);
    tfTheta.addActionListener(this);
    bPause.addActionListener(this);


    s = getParameter("Radius_gross");
    if (s != null) { tfR.setText(s); vR = stringToDouble(s); }

	s = getParameter("Radius_klein");
	if (s != null) { tfr.setText(s); vr = stringToDouble(s); }

	s = getParameter("Exzentr1");
	if (s != null) { tfexc1.setText(s); exc1 = stringToDouble(s); }

	s = getParameter("Exzentr2");
	if (s != null) { tfexc2.setText(s); exc2 = stringToDouble(s); }

	s = getParameter("Schrittzahl");
    if (s != null) { tfS.setText(s); kreisteile = Integer.parseInt(s); }

	s = getParameter("WindungenA");
	if (s != null) { tfwA.setText(s); wA = stringToDouble(s); }

	s = getParameter("WindungenB");
	if (s != null) { tfwB.setText(s); wB = stringToDouble(s); }


	s = getParameter("Winkel");
	if (s != null) { tfTheta.setText(s); wink = stringToDouble(s); }

	s = getParameter("ColorBackground");
	if (s != null) bgColor = new Color(Integer.parseInt(s,16));

	s = getParameter("ColorPanel");
	if (s != null) pColor = new Color(Integer.parseInt(s,16));

	s = getParameter("ColorSchrift");
	if (s != null) sColor = new Color(Integer.parseInt(s,16));

	s = getParameter("ColorX_Achse");
	if (s != null) xColor = new Color(Integer.parseInt(s,16));

	s = getParameter("ColorY_Achse");
	if (s != null) yColor = new Color(Integer.parseInt(s,16));

	s = getParameter("ColorZ_Achse");
	if (s != null) zColor = new Color(Integer.parseInt(s,16));

	s = getParameter("ColorA1");
	if (s != null) a1Color = new Color(Integer.parseInt(s,16));

	s = getParameter("ColorA2");
	if (s != null) a2Color = new Color(Integer.parseInt(s,16));

	s = getParameter("ColorA3");
	if (s != null) a3Color = new Color(Integer.parseInt(s,16));

	s = getParameter("ColorA4");
	if (s != null) a4Color = new Color(Integer.parseInt(s,16));

	s = getParameter("ColorB1");
	if (s != null) b1Color = new Color(Integer.parseInt(s,16));

	s = getParameter("ColorB2");
	if (s != null) b2Color = new Color(Integer.parseInt(s,16));

	s = getParameter("ColorB3");
	if (s != null) b3Color = new Color(Integer.parseInt(s,16));

	s = getParameter("ColorB4");
	if (s != null) b4Color = new Color(Integer.parseInt(s,16));


    theta = PI/180*(180 + wink);
    exc2write=exc2;
    on = true;
    thr = new Thread(this);
    thr.start();
  }

//----------------------------------------------------------

 // Stoppen der Animation:

  public void stop ()
  {
    removeAll();
    thr = null;
  }

//----------------------------------------------------------

  public void destroy()
  {
    bPause.removeActionListener(this);
    tfR.removeActionListener(this);
    tfr.removeActionListener(this);
    tfexc1.removeActionListener(this);
    tfexc2.removeActionListener(this);
    tfwA.removeActionListener(this);
    tfwB.removeActionListener(this);
    tfS.removeActionListener(this);
    tfTheta.removeActionListener(this);
    g1 = null;
    g2 = null;
    offscreen = null;
    System.gc();
  }


//----------------------------------------------------------

 // Laufen des Programms (Endlosschleife)

  public void run ()
  {
    long t0, t1;
    t0 = System.currentTimeMillis();

    Thread thisThread = Thread.currentThread();

	while (thr == thisThread)
    {
      paint(g2);
      g1.drawImage(offscreen,0,0,this);

      try {Thread.sleep(50);}
      catch (InterruptedException ie) {}

      t1 = System.currentTimeMillis();
      if (on) t += (t1-t0)/1000.0;
      t0 = t1;
    }

  }

//----------------------------------------------------------

  // Bildschirmkoordinaten (orthogonale Parallelprojektion):

  int screenU (double x, double y)
  {
    return (int)Math.round(u0+20*(a1*x+a2*y));
  }

//----------------------------------------------------------

  int screenV (double x, double y, double z)
  {
    return (int)Math.round(v0+20*(b1*x+b2*y+b3*z));
  }

//----------------------------------------------------------

// Koeffizienten fr Parallelprojektion:

  void calcCoeff ()
  {
    double sin = Math.sin(theta), cos = Math.cos(theta);
    a1 = Math.sin(phi); a2 = -Math.cos(phi);     // Nach "rechts"
    b1 = sin*a2; b2 = -sin*a1; b3 = -cos;        // Nach "oben"
    c1 = -cos*a2; c2 = cos*a1; c3 = -sin;        // Projektionsrichtung
  }

//----------------------------------------------------------

// Umwandlung eines Strings in eine Fliekommazahl:

  double stringToDouble (String s)
  {
    StringBuffer sbuf = new StringBuffer(s);
    double val;

    for (int i=0; i < sbuf.length(); i++) if (sbuf.charAt(i) == ',')

    sbuf.setCharAt(i,'.');
    try {val = Double.valueOf(sbuf.toString()).doubleValue();}
    catch (NumberFormatException e) {val = 0;}
    return val;
  }

//----------------------------------------------------------

  // Pfeil mit einfacher Dicke:
  // (u0,v0), (u1,v1) ... Endpunkte (Bildschirmkoordinaten)

  void drawArrow (int u0, int v0, int u1, int v1)
  {
    double w, dw = 0.2, r = 10, du = u1-u0, dv = v0-v1;
    if (du == 0 && dv == 0) return;
    g2.drawLine(u0,v0,u1,v1);
    w = Math.atan2(dv,du);
    u0 = (int)Math.round(u1-r*Math.cos(w+dw));
    v0 = (int)Math.round(v1+r*Math.sin(w+dw));
    g2.drawLine(u0,v0,u1,v1);
    u0 = (int)Math.round(u1-r*Math.cos(w-dw));
    v0 = (int)Math.round(v1+r*Math.sin(w-dw));
    g2.drawLine(u0,v0,u1,v1);
  }

//----------------------------------------------------------

  // Linie mit dreifacher Dicke:
  // (u0,v0), (u1,v1) ... Endpunkte (Bildschirmkoordinaten)

  void thickLine (int u0, int v0, int u1, int v1)
  {
    g2.drawLine(u0,v0,u1,v1);

    if (Math.abs(u1-u0) > Math.abs(v1-v0))
    {
      g2.drawLine(u0,v0-1,u1,v1-1);
      g2.drawLine(u0,v0+1,u1,v1+1);
    }
    else
    {
	  g2.drawLine(u0-1,v0,u1-1,v1);
	  g2.drawLine(u0+1,v0,u1+1,v1);
	}
  }

//----------------------------------------------------------

  // Pfeil mit dreifacher Dicke:
  // (u0,v0), (u1,v1) ... Endpunkte (Bildschirmkoordinaten)

  void thickArrow (int u0, int v0, int u1, int v1)
  {
    double w, dw = 0.2, r = 8, du = u1-u0, dv = v0-v1;

    if (du == 0 && dv == 0) return;

    thickLine(u0,v0,u1,v1);
    w = Math.atan2(dv,du);
    u0 = (int)Math.round(u1-r*Math.cos(w+dw));
    v0 = (int)Math.round(v1+r*Math.sin(w+dw));
    thickLine(u0,v0,u1,v1);
    u0 = (int)Math.round(u1-r*Math.cos(w-dw));
    v0 = (int)Math.round(v1+r*Math.sin(w-dw));
    thickLine(u0,v0,u1,v1);
  }

//----------------------------------------------------------

  // Achse mit Unterteilung:
  // (x1,y1,z1) ... Spitze

  void drawAxis (int u0, int v0, int u1, int v1)
  {
    int i, u, v, duu, dvv;
    double dU, dV, du, dv, length;
    dU = (u1-u0)/12.0; dV = (v1-v0)/12.0;
    du = -dV; dv = dU; length = Math.sqrt(du*du+dv*dv);
    duu = (int)Math.round(3*du/length);
    dvv = (int)Math.round(3*dv/length);
    drawArrow(u0,v0,u1,v1);

    for (i=1; i <= 11; i++)
    {
      u = (int)Math.round(u0+i*dU);
      v = (int)Math.round(v0+i*dV);
      //g2.drawLine(u-duu,v-dvv,u+duu,v+dvv);
    }
  }

//----------------------------------------------------------

  // Koordinatensystem:

 void drawCoordSystem ()
  {
    int u0, v0, u1, v1, a = 10;
    u0 = screenU(-a,0); v0 = screenV(-a,0,0);
    u1 = screenU(a,0); v1 = screenV(a,0,0);
    g2.setColor(xColor); drawAxis(u0,v0,u1,v1);
    g2.drawString("x",u1-4,v1+12);
    u0 = screenU(0,-a); v0 = screenV(0,-a,0);
    u1 = screenU(0,a); v1 = screenV(0,a,0);
    g2.setColor(yColor); drawAxis(u0,v0,u1,v1);
    g2.drawString("y",u1-4,v1+12);
    u0 = screenU(0,0); v0 = screenV(0,0,-a);
    u1 = u0; v1 = screenV(0,0,a);
    g2.setColor(zColor); drawAxis(u0,v0,u1,v1);
    g2.drawString("z",u1-12,v1+4);
  }

//----------------------------------------------------------


 // Torus:

  void drawTorus ()
  {
    int i,j,u001,v001,u01,v01,schr=0,farbe,farbe_alt;
    double winkelphi,winkeltheta,winkelphi1,winkeltheta1,uuu=0,vvv=0,www=0,u000,v000,w000,paramv,Lq,L,Lges,LA, schritt;
    double swphi,swph,swtheta,swthet,radiusklein,radiusgross,costheta,sintheta;
    double start1dX=0,start2dX=0,start1dY=0,start2dY=0,start1dZ=0,start2dZ=0,abBetrag,KreuzWinkel;
    String Stext;

    double z6=1000000, dexc2=1.0E-5;
    double abstand=0, spannung;

    radiusgross=vR;
    radiusklein=vr;
    paramv=radiusgross+radiusklein;

    exc2 +=dexc2;
    double da=vr*exc1, db=vr*exc2;
    LA=0;


if (cbA.getState())
{
  // erste Spulenwinklung


    swphi=wB;      //=d(theta)
    swtheta=wA;    //=d(phi)
    swph=swphi;
    Lges=0;

    winkelphi=0;
	winkeltheta=0; farbe=0;



	   for (j=1; j <= kreisteile; j++)
	   {

         abstand=paramv;
	     spannung= 1.0 + (abstand-vR)/(4*PI);

         winkeltheta +=swtheta*spannung;
         winkelphi +=swph/spannung;
         schr=j;

         if (winkeltheta > zPI) winkeltheta -= zPI;
         if (winkelphi > zPI) winkelphi -= zPI;

         farbe_alt=farbe;
         if ((winkeltheta < PI) && (winkelphi < PI )) farbe=1;
         if ((winkeltheta > PI) && (winkelphi < PI )) farbe=3;
         if ((winkeltheta < PI) && (winkelphi > PI )) farbe=2;
    	 if ((winkeltheta > PI) && (winkelphi > PI )) farbe=4;

	     if (farbe != farbe_alt)
    	 {
			 if (farbe==1) g2.setColor(a1Color);
			 if (farbe==2) g2.setColor(a2Color);
			 if (farbe==3) g2.setColor(a3Color);
			 if (farbe==4) g2.setColor(a4Color);
		 }

         costheta=Math.cos(winkeltheta);
         sintheta=Math.sin(winkeltheta);

         //Ei-Form aus parameter exc1 und exc2:
         radiusklein=vr + da*(costheta*costheta + costheta) - db*(sintheta*sintheta + sintheta);

         if (j==1) { uuu=radiusgross+radiusklein; vvv=0; www=0; }

         paramv=radiusgross+radiusklein*costheta;
         u000=uuu; v000=vvv; w000=www;

         uuu = paramv*Math.cos(winkelphi);
		 vvv = paramv*Math.sin(winkelphi);
		 www = radiusklein*sintheta;

    	 if(j==1) { start1dX=uuu-u000; start1dY=vvv-v000; start1dZ=www-w000; }

	     u001 = screenU(u000,v000); v001 = screenV(u000,v000,w000);
		 u01 = screenU(uuu,vvv); v01 = screenV(uuu,vvv,www);

	     g2.drawLine(u001,v001,u01,v01);

	     Lq=(uuu-u000)*(uuu-u000) + (vvv-v000)*(vvv-v000) + (www-w000)*(www-w000);
	     L=Math.sqrt(Lq);
	     Lges +=L;


	   }



    	     g2.setColor(sColor);
    	     Lq=Math.round(Lges*z6)/z6;
    	     LA=Lges;
    	     Stext = "LngeA= " + Double.toString(Lq) + " ";
		     g2.drawString(Stext,5,30);
		     schritt=Math.round(Lges/kreisteile*z6)/z6;
		 	 Stext = "" + Integer.toString(schr) + " mittl.Schritte " + "zu " + Double.toString(schritt) + "";
			 if (!cbB.getState()) g2.drawString(Stext,5,415);

   };// Ende if (cbA.getState())


if (cbB.getState())
{
// inverse Spulenwicklung

    paramv=radiusgross+radiusklein;

    swphi=wA;    // =d(phi)
	swtheta=wB;  // =d(theta)
	swthet=swtheta;
	Lges=0;

    winkeltheta=0; Lges=0;
    winkelphi=0; farbe=0;


	   for (j=1; j <= kreisteile; j++)
	   {

         abstand=paramv;
	     spannung= 1.0 + (abstand-vR)/(4*PI);

         winkeltheta -=swthet*spannung;
         winkelphi +=swphi/spannung;
         schr=j;

         if (winkeltheta < -zPI) winkeltheta +=zPI;
         if (winkelphi > zPI) winkelphi -= zPI;

         farbe_alt=farbe;
         if ((winkeltheta < -PI) && (winkelphi < PI )) farbe=3;
         if ((winkeltheta < -PI) && (winkelphi > PI )) farbe=4;
    	 if ((winkeltheta > -PI) && (winkelphi < PI )) farbe=1;
    	 if ((winkeltheta > -PI) && (winkelphi > PI )) farbe=2;

    	 if (farbe != farbe_alt)
    	 {
			 if (farbe==1) g2.setColor(b1Color);
			 if (farbe==2) g2.setColor(b2Color);
			 if (farbe==3) g2.setColor(b3Color);
			 if (farbe==4) g2.setColor(b4Color);
		 }

         costheta=Math.cos(winkeltheta);
         sintheta=Math.sin(winkeltheta);

         //Ei-Form aus parameter exc1 und exc2:
         radiusklein=vr + da*(costheta*costheta + costheta) - db*(sintheta*sintheta + sintheta);

         if (j==1) { uuu=radiusgross+radiusklein; vvv=0; www=0; }

         paramv=radiusgross+radiusklein*costheta;
         u000=uuu; v000=vvv; w000=www;

         uuu = paramv*Math.cos(winkelphi);
		 vvv = paramv*Math.sin(winkelphi);
		 www = radiusklein*sintheta;

         if(j==1) { start2dX=uuu-u000; start2dY=vvv-v000; start2dZ=www-w000; }

	     u001 = screenU(u000,v000); v001 = screenV(u000,v000,w000);
		 u01 = screenU(uuu,vvv); v01 = screenV(uuu,vvv,www);


	     g2.drawLine(u001,v001,u01,v01);

	     Lq=(uuu-u000)*(uuu-u000) + (vvv-v000)*(vvv-v000) + (www-w000)*(www-w000);
	     L=Math.sqrt(Lq);
	     Lges +=L;


	   }


         g2.setColor(sColor);

         exc2write=Math.round(exc2write*z6)/z6+1;
		 Stext = "exc2 +N = " + Double.toString(exc2write) + " ";
		 if (!cbA.getState()) g2.drawString(Stext,5,15);


	     Stext = "exc2 steigt pro Bild um " + Double.toString(dexc2) +  " , die Nachkommastellen sind das neue exc2 nach einem Klick";
	     if (!cbA.getState()) g2.drawString(Stext,5,430);



    }; // Ende if (cbB.getState())

			g2.setColor(sColor);


  }


//----------------------------------------------------------

 // Grafik:

  public void paint (Graphics g)
  {
    g.setFont(fSS);
    phi = omega*t;
    calcCoeff();
    g.setColor(bgColor);
    g.fillRect(0,0,width,height);
    drawCoordSystem();
    drawTorus();

  }

 //----------------------------------------------------------

 // Eingabe aus Textfeld:
  // tf .... Textfeld
  // min ... Minimum
  // max ... Maximum

  double inputTF (TextField tf, double min, double max)
  {
    double value = stringToDouble(tf.getText());

   /*
    if (value < min) value = min;
    if (value > max) value = max;
    */

    tf.setText("" + value);
    return value;
  }

//----------------------------------------------------------

  void newValue ()
  {
    vR = inputTF(tfR,-max,+max);
    vr = inputTF(tfr,-max,+max);
    exc2write=exc2;
    exc1 = inputTF(tfexc1,-max,+max);
    exc2 = inputTF(tfexc2,-max,+max);
    wA = inputTF(tfwA,-max,+max);
    wB = inputTF(tfwB,-max,+max);
    kreisteile = inputTF(tfS,-max,+max);
    double wink=inputTF(tfTheta,-360,360);
    theta = PI/180*(180+wink);
    calcCoeff();
  }

//----------------------------------------------------------

  public void actionPerformed (ActionEvent e)
  {
      newValue();
      on = !on;

  }

//----------------------------------------------------------

}

//----------------------------------------------------------
//----------------------------------------------------------
