
import java.applet.*;
import java.awt.*;
import java.awt.event.*;

//----------------------------------------------------------

public class Schnecke1 extends Applet implements ActionListener, Runnable
{
  int width = 900, totalWidth, height;         // Abmessungen
  Graphics g1, g2;
  Image offscreen;
  Color bgColor = Color.white;                  // Hintergrundfarbe Grafikbereich
  Color pColor = new Color(200,200,200);        // Farbe Hintergrund Formular
  Color sColor = Color.black;                   // Schriftfarbe
  Color xColor = Color.red;                     // Farbe X-Achse
  Color yColor = new Color(0,128,0);            // Farbe Y-Achse
  Color zColor = Color.blue;                    // Farbe Z-Achse
  Color a1Color = Color.black;                  // 4 Farben KurveA
  Color a2Color = Color.black;
  Color a3Color = Color.red;
  Color a4Color = Color.red;
  Color b1Color = Color.magenta;                // 4 Farben KurveB
  Color b2Color = Color.magenta;
  Color b3Color = Color.blue;
  Color b4Color = Color.blue;
  Font fSS;                                     // Zeichensatz
  Panel p;
  Checkbox cbA, cbB, cbC;                           // Schalter
  Button bPause;
  Label lR, lhfakt, lsvh, lstarth, lneun;
  TextField tfR, tfsvh, tfneun, tfhfakt, tfstarth, tfTheta, tfbvk;
  Thread thr;
  double t;                                    // Zeit (s)
  boolean on;                                  // Flag fr Bewegung
  final double omega = -Math.PI/128;            // Winkelgeschwindigkeit (1/s)
  final double PI=Math.PI, zPI=2*PI, dreiPI=3*PI;
  int u0, v0;                    // Ursprung
  double theta;                                // Winkel bezglich x-y-Ebene
  double phi;                                  // Winkel bezglich x-Achse
  double a1, a2, b1, b2, b3, c1, c2, c3;       // Koeffizienten fr Projektion
  double vR, kreisteile, bvk, vN, svh, delta, hfakt, starth, neun;   // Torusgren R,r, Windg., Kreisteile
  final int max = 1000;                        // Maximalwert fr Koordinaten

  String KA,KB;
  String lang;                                 // Sprache (Parameter aus Applet-Tag)
  String[] text;
  String[] german = { "Mae und Winkelschritte", "Starthhe", "Kipp-Winkel", "Stop / Weiter", "",
  "Daten speichern im HTM-Code","Download www.webstickers.de"," G.Mueller 2004,  W.Fendt 1998", "Bildverkleinerung" };
//um z-achse,um Schlauch

//----------------------------------------------------------

 // Komponente zum Panel hinzufgen:
  // comp .... Komponente
  // color ... Hintergrundfarbe
  // x ....... Spalte
  // y ....... Zeile
  // w ....... Breite
  // top usw.. Abstnde zu den benachbarten Komponenten

  void addComponent (Component comp, Color color, int x, int y, int w,
    int top, int left, int bottom, int right)
  {
    GridBagConstraints c = new GridBagConstraints();
    c.gridx = x; c.gridy = y; c.gridwidth = w; c.gridheight = 1;
    c.fill = GridBagConstraints.HORIZONTAL;
    c.anchor = GridBagConstraints.CENTER;
    c.weightx = 1; c.weighty = 1;
    c.insets = new Insets(top,left,bottom,right);
    ((GridBagLayout)p.getLayout()).setConstraints(comp,c);
    comp.setFont(fSS); comp.setBackground(color);
    p.add(comp);
  }





//----------------------------------------------------------

  public void init()
  {
    int i, j;
    totalWidth = getSize().width;
    height = getSize().height;

    g1 = getGraphics();
    offscreen = createImage(width,height);
    g2 = offscreen.getGraphics();
    fSS = new Font("SansSerif",Font.BOLD,12);
    setLayout(new BorderLayout());
    u0 = width/2; v0 = height/2;
  }

//----------------------------------------------------------

 // Starten der Animation:

  public void start ()
  {

    String s, kt="360";
    double wink=30.0;
    text = german;
    lang = getParameter("language");
    if (lang == null) lang = "German";

    p = new Panel();
    p.setLayout(new GridBagLayout());
    p.setBackground(pColor);
    addComponent(new Label(text[0]),pColor,0,0,3,30,10,0,10);

    lR = new Label("Maximal-Radius="); lR.setForeground(Color.black);
    addComponent(lR,pColor,0,1,1,0,10,0,0);

    tfR = new TextField(8); tfR.setText("4");
    addComponent(tfR,Color.white,1,1,1,0,0,0,20);

    lsvh = new Label("Windg.pro Umlauf="); lsvh.setForeground(Color.black);
    addComponent(lsvh,pColor,0,5,1,0,10,0,0);

    tfsvh = new TextField(8); tfsvh.setText("63");
    addComponent(tfsvh,Color.white,1,5,1,0,0,0,20);

    lneun = new Label("R-Verkrzung  k="); lneun.setForeground(Color.black);
    addComponent(lneun,pColor,0,6,1,0,10,0,0);

    tfneun = new TextField(8); tfneun.setText("9");
    addComponent(tfneun,Color.white,1,6,1,0,0,0,20);

    lhfakt = new Label("Hhenfaktor"); lhfakt.setForeground(Color.black);
    addComponent(lhfakt,pColor,0,7,1,0,10,0,0);

    tfhfakt = new TextField(4); tfhfakt.setText("2.35");
    addComponent(tfhfakt,Color.white,1,7,1,10,0,0,20);

    lstarth = new Label(text[1]); lstarth.setForeground(Color.black);
    addComponent(lstarth,pColor,0,8,1,0,10,0,0);

    tfstarth = new TextField(8); tfstarth.setText("0");
    addComponent(tfstarth,Color.white,1,8,1,0,0,0,20);

    addComponent(new Label(text[2]),pColor,0,9,1,0,10,0,0);

    tfTheta = new TextField(4); tfTheta.setText("30");
    addComponent(tfTheta,Color.white,1,9,1,10,0,0,20);

    addComponent(new Label(text[8]),pColor,0,10,1,0,10,0,0);

    tfbvk = new TextField(4); tfbvk.setText("1");
    addComponent(tfbvk,Color.white,1,10,1,10,0,0,20);


    s = getParameter("anzeigenKurveA");
    if (s == null) cbA = new Checkbox("KurveA", true);
	if ("false".equals(s))
	{ cbA = new Checkbox("KurveA", false);}
	else
	{ cbA = new Checkbox("KurveA", true); }

	s = getParameter("anzeigenKurveB");
	if (s == null) cbB = new Checkbox("KurveB", true);
	if ("false".equals(s))
	{ cbB = new Checkbox("KurveB",false); }
	else
	{ cbB = new Checkbox("KurveB", true); }

	s = getParameter("anzeigenKurveC");
	if (s == null) cbC = new Checkbox("KurveC", true);
	if ("false".equals(s))
	{ cbC = new Checkbox("KurveC",false); }
	else
	{ cbC = new Checkbox("KurveC", true); }


	addComponent(cbA,pColor,0,11,1,0,20,0,0);       // Hinzufgen zur Schaltflche
	addComponent(cbB,pColor,1,11,1,0,0,0,0);
	addComponent(cbC,pColor,2,11,1,0,0,0,0);

    bPause = new Button(text[3]);
    addComponent(bPause,Color.white,0,12,4,10,10,0,10);
    addComponent(new Label(text[4]),pColor,0,13,4,0,10,0,0);
    addComponent(new Label(text[5]),pColor,0,14,4,0,10,0,0);
    addComponent(new Label(text[6]),pColor,0,15,4,0,10,0,0);
    addComponent(new Label(text[7]),pColor,0,16,4,0,10,0,0);
    add("East",p);

    tfR.addActionListener(this);
    tfsvh.addActionListener(this);
    tfneun.addActionListener(this);
    tfstarth.addActionListener(this);
    tfhfakt.addActionListener(this);
    tfTheta.addActionListener(this);
    tfbvk.addActionListener(this);
    bPause.addActionListener(this);


    s = getParameter("Radius_gross");
    if (s != null) { tfR.setText(s); vR = stringToDouble(s); }

    s = getParameter("WinkelSchrittverhaeltnis");
    if (s != null) { tfsvh.setText(s); svh = stringToDouble(s); }

    s = getParameter("kStattNeun");
    if (s != null) { tfneun.setText(s); neun = stringToDouble(s); }

    s = getParameter("Starthoehe");
    if (s != null) { tfstarth.setText(s); starth = stringToDouble(s); }
    starth=-starth;

    s = getParameter("RadiusunterschiedInvers");
    if (s != null) { delta = stringToDouble(s); }
    delta=1/delta;

    s = getParameter("Hoehenfaktor");
    if (s != null) { tfhfakt.setText(s); hfakt = stringToDouble(s); }

 	s = getParameter("Schrittzahl");
    if (s != null) { kreisteile = Integer.parseInt(s); }

	s = getParameter("Kippwinkel");
	if (s != null) { tfTheta.setText(s); wink = stringToDouble(s); }

    s = getParameter("Bildverkleinerung");
	if (s != null) { tfbvk.setText(s); bvk = stringToDouble(s); }

    s = getParameter("L_mal_X");
	if (s != null) { vN = stringToDouble(s); }

	s = getParameter("ColorBackground");
	if (s != null) bgColor = new Color(Integer.parseInt(s,16));

	s = getParameter("ColorPanel");
	if (s != null) pColor = new Color(Integer.parseInt(s,16));

	s = getParameter("ColorSchrift");
	if (s != null) sColor = new Color(Integer.parseInt(s,16));

	s = getParameter("ColorX_Achse");
	if (s != null) xColor = new Color(Integer.parseInt(s,16));

	s = getParameter("ColorY_Achse");
	if (s != null) yColor = new Color(Integer.parseInt(s,16));

	s = getParameter("ColorZ_Achse");
	if (s != null) zColor = new Color(Integer.parseInt(s,16));

    theta = PI/180*(180 + wink);
    on = true;
    thr = new Thread(this);
    thr.start();
  }

//----------------------------------------------------------

 // Stoppen der Animation:

  public void stop ()
  {
    removeAll();
    thr = null;
  }

//----------------------------------------------------------

  public void destroy()
  {
    bPause.removeActionListener(this);
    tfR.removeActionListener(this);
    tfsvh.removeActionListener(this);
    tfneun.removeActionListener(this);
    tfstarth.removeActionListener(this);
    tfhfakt.removeActionListener(this);
    tfTheta.removeActionListener(this);
    tfbvk.removeActionListener(this);
    g1 = null;
    g2 = null;
    offscreen = null;
    System.gc();
  }


//----------------------------------------------------------

 // Laufen des Programms (Endlosschleife)

  public void run ()
  {
    long t0, t1;
    t0 = System.currentTimeMillis();

    Thread thisThread = Thread.currentThread();

	while (thr == thisThread)
    {
      paint(g2);
      g1.drawImage(offscreen,0,0,this);

      try {Thread.sleep(50);}
      catch (InterruptedException ie) {}

      t1 = System.currentTimeMillis();
      if (on) t += (t1-t0)/1000.0;
      t0 = t1;
    }

  }

//----------------------------------------------------------

  // Bildschirmkoordinaten (orthogonale Parallelprojektion):

  int screenU (double x, double y)
  {
    x=x/bvk; y=y/bvk;
    return (int)Math.round(u0+20*(a1*x+a2*y));
  }

//----------------------------------------------------------

  int screenV (double x, double y, double z)
  {
	x=x/bvk; y=y/bvk; z=z/bvk;
    return (int)Math.round(v0+20*(b1*x+b2*y+b3*z));
  }

//----------------------------------------------------------

// Koeffizienten fr Parallelprojektion:

  void calcCoeff ()
  {
    double sin = Math.sin(theta), cos = Math.cos(theta);
    a1 = Math.sin(phi); a2 = -Math.cos(phi);     // Nach "rechts"
    b1 = sin*a2; b2 = -sin*a1; b3 = -cos;        // Nach "oben"
    c1 = -cos*a2; c2 = cos*a1; c3 = -sin;        // Projektionsrichtung
  }

//----------------------------------------------------------

// Umwandlung eines Strings in eine Fliekommazahl:

  double stringToDouble (String s)
  {
    StringBuffer sbuf = new StringBuffer(s);
    double val;

    for (int i=0; i < sbuf.length(); i++) if (sbuf.charAt(i) == ',')

    sbuf.setCharAt(i,'.');
    try {val = Double.valueOf(sbuf.toString()).doubleValue();}
    catch (NumberFormatException e) {val = 0;}
    return val;
  }

//----------------------------------------------------------

  // Pfeil mit einfacher Dicke:
  // (u0,v0), (u1,v1) ... Endpunkte (Bildschirmkoordinaten)

  void drawArrow (int u0, int v0, int u1, int v1)
  {
    double w, dw = 0.2, r = 10, du = u1-u0, dv = v0-v1;
    if (du == 0 && dv == 0) return;
    g2.drawLine(u0,v0,u1,v1);
    w = Math.atan2(dv,du);
    u0 = (int)Math.round(u1-r*Math.cos(w+dw));
    v0 = (int)Math.round(v1+r*Math.sin(w+dw));
    g2.drawLine(u0,v0,u1,v1);
    u0 = (int)Math.round(u1-r*Math.cos(w-dw));
    v0 = (int)Math.round(v1+r*Math.sin(w-dw));
    g2.drawLine(u0,v0,u1,v1);
  }

//----------------------------------------------------------

  // Linie mit dreifacher Dicke:
  // (u0,v0), (u1,v1) ... Endpunkte (Bildschirmkoordinaten)

  void thickLine (int u0, int v0, int u1, int v1)
  {
    g2.drawLine(u0,v0,u1,v1);

    if (Math.abs(u1-u0) > Math.abs(v1-v0))
    {
      g2.drawLine(u0,v0-1,u1,v1-1);
      g2.drawLine(u0,v0+1,u1,v1+1);
    }
    else
    {
	  g2.drawLine(u0-1,v0,u1-1,v1);
	  g2.drawLine(u0+1,v0,u1+1,v1);
	}
  }

//----------------------------------------------------------

  // Pfeil mit dreifacher Dicke:
  // (u0,v0), (u1,v1) ... Endpunkte (Bildschirmkoordinaten)

  void thickArrow (int u0, int v0, int u1, int v1)
  {
    double w, dw = 0.2, r = 8, du = u1-u0, dv = v0-v1;

    if (du == 0 && dv == 0) return;

    thickLine(u0,v0,u1,v1);
    w = Math.atan2(dv,du);
    u0 = (int)Math.round(u1-r*Math.cos(w+dw));
    v0 = (int)Math.round(v1+r*Math.sin(w+dw));
    thickLine(u0,v0,u1,v1);
    u0 = (int)Math.round(u1-r*Math.cos(w-dw));
    v0 = (int)Math.round(v1+r*Math.sin(w-dw));
    thickLine(u0,v0,u1,v1);
  }

//----------------------------------------------------------

  // Achse mit Unterteilung:
  // (x1,y1,z1) ... Spitze

  void drawAxis (int u0, int v0, int u1, int v1)
  {
    int i, u, v, duu, dvv;
    double dU, dV, du, dv, length;
    dU = (u1-u0)/12.0; dV = (v1-v0)/12.0;
    du = -dV; dv = dU; length = Math.sqrt(du*du+dv*dv);
    duu = (int)Math.round(3*du/length);
    dvv = (int)Math.round(3*dv/length);
    drawArrow(u0,v0,u1,v1);

    for (i=1; i <= 11; i++)
    {
      u = (int)Math.round(u0+i*dU);
      v = (int)Math.round(v0+i*dV);
      //g2.drawLine(u-duu,v-dvv,u+duu,v+dvv);
    }
  }

//----------------------------------------------------------

  // Koordinatensystem:

 void drawCoordSystem ()
  {
    int u0, v0, u1, v1, a = 10;
    u0 = screenU(-a,0); v0 = screenV(-a,0,0);
    u1 = screenU(a,0); v1 = screenV(a,0,0);
    g2.setColor(xColor); drawAxis(u0,v0,u1,v1);
    g2.drawString("x",u1-4,v1+12);
    u0 = screenU(0,-a); v0 = screenV(0,-a,0);
    u1 = screenU(0,a); v1 = screenV(0,a,0);
    g2.setColor(yColor); drawAxis(u0,v0,u1,v1);
    g2.drawString("y",u1-4,v1+12);
    u0 = screenU(0,0); v0 = screenV(0,0,-a);
    u1 = u0; v1 = screenV(0,0,a);
    g2.setColor(zColor); drawAxis(u0,v0,u1,v1);
    g2.drawString("z",u1-12,v1+4);
  }

//----------------------------------------------------------


 // Torus:

  void drawTorus ()
  {
    int i,j,u001,v001,u01,v01,is, Nkreisteile=(int)(kreisteile*vN), NSkreisteile=(int)(kreisteile*vN*svh);
    double winkelphi,uuu=0,vvv=0,www=starth,u000,v000,w000,paramv,Lq,L=0,Lges;
    double swphi, swtheta=0, swz, winkeltheta, radius=0, radiusgross=vR, R_mal9=vR*vN, radiusklein=0;
    String Stext;
    double z6=1000000, dR=0, hoehe=starth;
    double Rgrenz=1, LdR, costheta, sintheta, Schlauchdicke=0;
    boolean rotb;

    uuu=radiusgross; vvv=0; www=starth;
    paramv = radiusgross;
    swphi = zPI/kreisteile;
    swz = swphi*hfakt;
	winkelphi=0;
	hoehe=starth;
	g2.setColor(Color.gray);

	double Rneu=radiusgross, Ralt=Rneu, Rverh=1.0;
	int izeile=0;



is=0;
// C grau
while (is <= Nkreisteile)
{
         is++;

         dR = swphi*paramv/neun;
         hoehe += swz/paramv;
         winkelphi +=swphi;

         u000=uuu; v000=vvv; w000=www;

         uuu = paramv*Math.cos(winkelphi);
		 vvv = paramv*Math.sin(winkelphi);
		 www = hoehe;

		 paramv -= dR;

         if (winkelphi > zPI)
         {
		   winkelphi -= zPI;
		   Ralt=Rneu; Rneu=paramv; Rverh=Rneu/Ralt;
		   Stext = "R_neu/R_alt= " + Double.toString(Rverh) + " ";
		   izeile +=15;
		   if (izeile == 30 ) g2.drawString(Stext,5,izeile);
         }

	     u001 = screenU(u000,v000); v001 = screenV(u000,v000,w000);
		 u01 = screenU(uuu,vvv); v01 = screenV(uuu,vvv,www);

	     if (cbC.getState()) g2.drawLine(u001,v001,u01,v01);


 } // Ende while1

 Schlauchdicke=(1-Rverh)/Rverh;

 if (cbC.getState())
 {
  g2.setColor(Color.black);

  is=0;

// C schwarz
 while (is <= Nkreisteile)

 {
          is++;

          dR = swphi*paramv/neun;
          hoehe -= swz/paramv;
          winkelphi +=swphi;

          u000=uuu; v000=vvv; w000=www;

         uuu = paramv*Math.cos(winkelphi);
 		 vvv = paramv*Math.sin(winkelphi);
 		 www = hoehe;

 		 paramv += dR;

 	     u001 = screenU(u000,v000); v001 = screenV(u000,v000,w000);
 		 u01 = screenU(uuu,vvv); v01 = screenV(uuu,vvv,www);

 	     g2.drawLine(u001,v001,u01,v01);


  } // Ende while2




}  // Ende if (cbC.getState())

if (cbA.getState() || cbB.getState())
{
    radius = radiusgross;
    radiusklein = radius*Schlauchdicke-delta;

    uuu = radiusgross+radiusklein; vvv=0; www=starth;
    u000=uuu; v000=vvv; w000=www;
    u001 = screenU(u000,v000); v001 = screenV(u000,v000,w000);
	u01 = screenU(uuu,vvv); v01 = screenV(uuu,vvv,www);
	g2.drawLine(u001,v001,u01,v01);

    winkelphi=0;
	winkeltheta=0;
	hoehe=starth;

    swtheta=zPI/kreisteile;
    swphi=swtheta/svh;
    swz = swphi*hfakt;

    g2.setColor(Color.red);

is=0;

//A=oben

while (is <= NSkreisteile)
{
         is++;

         dR = swphi*radius/neun;
         hoehe += swz/radius;
         winkeltheta +=swtheta;
         winkelphi +=swphi;

         costheta=Math.cos(winkeltheta);
         sintheta=Math.sin(winkeltheta);

         radius -= dR;
         radiusklein = radius*Schlauchdicke-delta;
         u000=uuu; v000=vvv; w000=www;

         paramv=radius+radiusklein*costheta;

         uuu = paramv*Math.cos(winkelphi);
		 vvv = paramv*Math.sin(winkelphi);
		 www = radiusklein*sintheta+hoehe;

	     u001 = screenU(u000,v000); v001 = screenV(u000,v000,w000);
		 u01 = screenU(uuu,vvv); v01 = screenV(uuu,vvv,www);

	     if (cbA.getState()) { g2.drawLine(u001,v001,u01,v01); }


} // Ende while4


} // Ende if (cbA.get...

if (cbB.getState())
{

    winkelphi=0;
	winkeltheta=0;

    g2.setColor(Color.blue);

    is=0;

// B=unten
while (is <= NSkreisteile)
{
         is++;

         dR = swphi*radius/neun;
         hoehe -= swz/radius;
         winkeltheta +=swtheta;
         winkelphi +=swphi;

         costheta=Math.cos(winkeltheta);
         sintheta=Math.sin(winkeltheta);

         radius += dR;
         radiusklein = radius*Schlauchdicke-delta;
         u000=uuu; v000=vvv; w000=www;

         paramv=radius+radiusklein*costheta;

         uuu = paramv*Math.cos(winkelphi);
		 vvv = paramv*Math.sin(winkelphi);
		 www = radiusklein*sintheta+hoehe;

	     u001 = screenU(u000,v000); v001 = screenV(u000,v000,w000);
		 u01 = screenU(uuu,vvv); v01 = screenV(uuu,vvv,www);

	     g2.drawLine(u001,v001,u01,v01);


} // Ende while5



   };// Ende if (cbB.getState())



  }


//----------------------------------------------------------

 // Grafik:

  public void paint (Graphics g)
  {
    g.setFont(fSS);
    phi = omega*t;

    calcCoeff();
    g.setColor(bgColor);
    g.fillRect(0,0,width,height);
    drawCoordSystem();
    drawTorus();

  }

 //----------------------------------------------------------

 // Eingabe aus Textfeld:
  // tf .... Textfeld
  // min ... Minimum
  // max ... Maximum

  double inputTF (TextField tf, double min, double max)
  {
    double value = stringToDouble(tf.getText());

   /*
    if (value < min) value = min;
    if (value > max) value = max;
    */

    tf.setText("" + value);
    return value;
  }

//----------------------------------------------------------

  void newValue ()
  {
    String kt="360";

    vR = inputTF(tfR,-max,+max);
    svh = inputTF(tfsvh,-max,+max);
    neun = inputTF(tfneun,-max,+max);
    starth = inputTF(tfstarth,-max,+max);
    starth=-starth;
    hfakt = inputTF(tfhfakt,-max,+max);

    double wink=inputTF(tfTheta,-360,360);
    theta = PI/180*(180+wink);
    if (bvk > 0) { bvk = inputTF(tfbvk,-max,+max); }
    else
    { bvk=1.0; tfbvk.setText("1.0"); }

    calcCoeff();
  }

//----------------------------------------------------------

  public void actionPerformed (ActionEvent e)
  {
      newValue();
      on = !on;

  }

//----------------------------------------------------------

}

//----------------------------------------------------------
//----------------------------------------------------------
